GNU bug report logs - #44020
28.0.50; Prefer selection of colour emoji fonts?

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Lars Ingebrigtsen <larsi@HIDDEN>; dated Thu, 15 Oct 2020 18:12:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 19 Oct 2020 18:34:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 19 14:34:54 2020
Received: from localhost ([127.0.0.1]:42338 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kUZzh-0005K3-Sd
	for submit <at> debbugs.gnu.org; Mon, 19 Oct 2020 14:34:54 -0400
Received: from mail-wm1-f51.google.com ([209.85.128.51]:36676)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1kUZzf-0005Jq-VT
 for 44020 <at> debbugs.gnu.org; Mon, 19 Oct 2020 14:34:52 -0400
Received: by mail-wm1-f51.google.com with SMTP id e2so519814wme.1
 for <44020 <at> debbugs.gnu.org>; Mon, 19 Oct 2020 11:34:51 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version; bh=obdMx9gm2PofzJRbziRT4mxGmrsCYiP1YK2G0Kj251s=;
 b=hOcusgq/n+cKpMqBUIF5ZgcXaRiW0lFukS7yMqi3Bcqqe41MPYv9/5pVoT/RzyZ8da
 bPEmDIQIgQ4/1JlFnMyERabbXSyPWI59ehclNBhir21kA/M/xJx2+eMsDftLqHlaVmEQ
 /s17aMCjWp5gFNoAJnj5zI4PPqElTcekMAUowzjXzkaa09qhErCliQgdeRK9KDWUfDI5
 R60Gx7f+ZQoXzPuV3qayUFSG9uEAO53GIDvnurgas+ZI+lhnN6GqaR7Sm9lDhoU5XKzl
 ikrYsUvefofsPNDlLq9b/HuMAbO7A7rXBM3vBei1h6OhSl+B/xSDrYXqfw6Ctt/k/HdC
 EMdg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version;
 bh=obdMx9gm2PofzJRbziRT4mxGmrsCYiP1YK2G0Kj251s=;
 b=Qi2lA+U5KgwRasOdDMpDgZPuB4tMjE0su1RA20YkpAMzqa3gq8IgMTzCoCAehyJYd8
 YGJnzDID/ROrzM1aebpxP1LlQGkiuLfkDAjZVWbz6ZJSQfgHYsoFM/L8Jxc4p/Jkou9d
 AQCqIcPNxymkcm0c05MVID3lcmmBD09LkJVNvg/Mu02tUh5INlLYuIKxFfeQ5037ozaR
 eYdiViL8hvsgYQbMiygbJT46Od2FCjVp3l3zEKO60uTjj3WpBWgxcreMGsMHV412H/5L
 wP1niyIIvIMZgq36vX4U+NKW36PpprTAoCu+W6Z9DT7P8urJ8OHToN0ye4AQeYpvnj4I
 SeZA==
X-Gm-Message-State: AOAM531IjxAkSzLfScyl7bAuMIZh7z98lJj9QSK7AV8gvjyAMs6oAL1L
 qcoqpHT1rMJIyK3R0zRGjGQ=
X-Google-Smtp-Source: ABdhPJxquKQrfOYx1XK5TZuvZKE7RX60iuPbvJfxkmnn9zNBYYleJkHqRVGo0wpNEpwnbNPNdmOsbg==
X-Received: by 2002:a1c:a70d:: with SMTP id q13mr553132wme.132.1603132485848; 
 Mon, 19 Oct 2020 11:34:45 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:4453:8239:2ff5:dfe4])
 by smtp.gmail.com with ESMTPSA id e25sm712756wra.71.2020.10.19.11.34.43
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 19 Oct 2020 11:34:43 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <87imba4454.fsf@HIDDEN>
 <m2mu0ieb6m.fsf@HIDDEN> <83k0vmp8n8.fsf@HIDDEN>
Date: Mon, 19 Oct 2020 20:34:41 +0200
In-Reply-To: <83k0vmp8n8.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 19 Oct
 2020 17:55:55 +0300")
Message-ID: <m2ft6adpz2.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

>>>>> On Mon, 19 Oct 2020 17:55:55 +0300, Eli Zaretskii <eliz@HIDDEN> said:

    >> From: Robert Pluim <rpluim@HIDDEN>
    >> Cc: 44020 <at> debbugs.gnu.org,  Eli Zaretskii <eliz@HIDDEN>
    >> Date: Mon, 19 Oct 2020 12:56:33 +0200
    >>=20
    >> So revisiting this, it turns out I have *two* features sitting in my=
 workspace:
    >>=20
    >> 1. splitting out the emoji into a separate script and setting the ri=
ght
    >> fontset
    >> 2. adding composition rules for the zwj emoji described in
    >> emoji-zwj-sequences.txt
    >>=20
    >> [2] has some complications regarding the default display of the
    >> variation-selector, so I=CA=BCll leave that aside for now, and conti=
nue on
    >> updating [1] to Unicode 13.0

    Eli> Thanks.

    Eli> Can you summarize the problems with [2]?  I thought we had all of =
that
    Eli> figured out back when we discussed this.

Perhaps we did: I have no clear memory of what we decided, so I=CA=BCll
have to go and re-read it.

I=CA=BCm attaching a gzipped patch for emoji support (it contains the
entire emoji-data.txt from Unicode 13.0 =F0=9F=99=82), which works for me on
macOS when I do

(set-fontset-font t 'emoji '("Apple Color Emoji . "iso1064601") nil
'prepend)

It *should* work as-is on GNU/Linux, but for some reason Emacs is
completely refusing to use any Emoji fonts for me there. It=CA=BCs possible
I=CA=BCve messed up my system somehow, since emacs-27 has the same issue,
but I=CA=BCm seeing some very suspicious results from
ftcrfont_glyph_extents (the font average width is always 0), so perhaps
we need to adjust our font code.

Testing appreciated.

Robert
--=20

--=-=-=
Content-Type: application/octet-stream
Content-Disposition: attachment;
 filename=0001-emoji-using-blocks.txt.patch.gz
Content-Transfer-Encoding: base64
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--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 19 Oct 2020 14:56:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 19 10:56:03 2020
Received: from localhost ([127.0.0.1]:42023 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kUWZv-0001ss-I0
	for submit <at> debbugs.gnu.org; Mon, 19 Oct 2020 10:56:03 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58234)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kUWZu-0001sO-3I
 for 44020 <at> debbugs.gnu.org; Mon, 19 Oct 2020 10:56:02 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35329)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kUWZo-0000Mt-MT; Mon, 19 Oct 2020 10:55:56 -0400
Received: from [176.228.60.248] (port=2048 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kUWZi-00087W-IR; Mon, 19 Oct 2020 10:55:54 -0400
Date: Mon, 19 Oct 2020 17:55:55 +0300
Message-Id: <83k0vmp8n8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-Reply-To: <m2mu0ieb6m.fsf@HIDDEN> (message from Robert Pluim on Mon, 19
 Oct 2020 12:56:33 +0200)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <87imba4454.fsf@HIDDEN>
 <m2mu0ieb6m.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Robert Pluim <rpluim@HIDDEN>
> Cc: 44020 <at> debbugs.gnu.org,  Eli Zaretskii <eliz@HIDDEN>
> Date: Mon, 19 Oct 2020 12:56:33 +0200
> 
> So revisiting this, it turns out I have *two* features sitting in my workspace:
> 
> 1. splitting out the emoji into a separate script and setting the right
>   fontset
> 2. adding composition rules for the zwj emoji described in
>   emoji-zwj-sequences.txt
> 
> [2] has some complications regarding the default display of the
> variation-selector, so Iʼll leave that aside for now, and continue on
> updating [1] to Unicode 13.0

Thanks.

Can you summarize the problems with [2]?  I thought we had all of that
figured out back when we discussed this.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 19 Oct 2020 10:56:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 19 06:56:43 2020
Received: from localhost ([127.0.0.1]:40114 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kUSqJ-0007cP-1d
	for submit <at> debbugs.gnu.org; Mon, 19 Oct 2020 06:56:43 -0400
Received: from mail-wm1-f46.google.com ([209.85.128.46]:36360)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1kUSqH-0007c7-02
 for 44020 <at> debbugs.gnu.org; Mon, 19 Oct 2020 06:56:41 -0400
Received: by mail-wm1-f46.google.com with SMTP id e2so12347218wme.1
 for <44020 <at> debbugs.gnu.org>; Mon, 19 Oct 2020 03:56:40 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:message-id:mime-version
 :content-transfer-encoding;
 bh=hcvS/K6KzXgW+psD2Ruwc5DD/UykP6tznNU7jYgQMqI=;
 b=jMNAPMix0PuT6SDmz/y8cro1tpP/ACGI2CunkMK83trbC9sy13EWncxzryGhJ+hK3g
 9wNurTyiE5qeLf/QqbMzi0WxikI8JqXJyvI6feB+EeTz0K9J5lctg4Ik37mJpMLNcKx7
 JwTKwEtssXwuLacETuSWD7J6KM5XNyWoPn3VMMkm8BoUDa5UUEKdmLtbNCr9uchXNhHS
 A63OfcTha2y2pPwjr0C1BaEMiJuXw5ZyxQQx20FlKAdFYIRIPGqzeqyXDQW5Xqx94DfQ
 nBblTXUtCGh3J7m571THqjk/q30xtoSQrmaYr4DRLpigBBdif2cVMvch4jbFgoHXbhbn
 rA9w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=hcvS/K6KzXgW+psD2Ruwc5DD/UykP6tznNU7jYgQMqI=;
 b=cCdhd9jlVbk63Hz15Zy86Jn/WJKULqP4q81Vy61nbfx6+1a7hm53vnXKYOHH2lTGng
 24gvj8V72VBihbRI/8jP/CJqxTK14mKoAT1bAHFlCrf1So8xPgh9bHlaEPZGXP7762+3
 /to1i9cDPYtnxIy9PmNpKZSp51CRRYLsiSKpdzN3R68QsLAdLOn+7yUvip+rw/FGx9ry
 YBfGjDZFnKDL6HryN3ucxKHZINRvj4nKKujvp4dtjp0461bwfTjUArRWoD1hyuO5FZMv
 hN0zjAUXwTKGipLGWqgVZ7Qe2CRYYLmXYvQ7xxzxOxEzPhL2s3zGfCuSKdM3qsq5iFTy
 TLZw==
X-Gm-Message-State: AOAM533HPY8PH7J5j1LEJCMqq9K0xA4Ez/VxC5HGqZsKPXBLEy+8bfpo
 9aJlssLUpWnh2tp7tTGy+sc=
X-Google-Smtp-Source: ABdhPJzexc/8Rb9g10gLOBl4inIGL0Qtt4Ju7RR6xAByVbJj2fYLVaFL35zxCudxX8C9aD9ZTBNQgg==
X-Received: by 2002:a7b:c181:: with SMTP id y1mr16707372wmi.58.1603104995029; 
 Mon, 19 Oct 2020 03:56:35 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:4453:8239:2ff5:dfe4])
 by smtp.gmail.com with ESMTPSA id e11sm12594439wrj.75.2020.10.19.03.56.33
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 19 Oct 2020 03:56:34 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <87imba4454.fsf@HIDDEN>
Date: Mon, 19 Oct 2020 12:56:33 +0200
Message-ID: <m2mu0ieb6m.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Fri, 16 Oct 2020 16:49:43 +0200, Lars Ingebrigtsen <larsi@HIDDEN=
> said:

    Lars> Robert Pluim <rpluim@HIDDEN> writes:
    >> I=CA=BCll see if I can clean this up this weekend and throw it on a =
branch.

    Lars> Looking forward to it.  :-)  And I agree with Eli; doing it on th=
e trunk
    Lars> would be fine.

So revisiting this, it turns out I have *two* features sitting in my worksp=
ace:

1. splitting out the emoji into a separate script and setting the right
  fontset
2. adding composition rules for the zwj emoji described in
  emoji-zwj-sequences.txt

[2] has some complications regarding the default display of the
variation-selector, so I=CA=BCll leave that aside for now, and continue on
updating [1] to Unicode 13.0

Robert
--=20




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 19 Oct 2020 08:35:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 19 04:35:17 2020
Received: from localhost ([127.0.0.1]:39928 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kUQdR-0005iM-34
	for submit <at> debbugs.gnu.org; Mon, 19 Oct 2020 04:35:17 -0400
Received: from quimby.gnus.org ([95.216.78.240]:60230)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kUQdP-0005i9-8B
 for 44020 <at> debbugs.gnu.org; Mon, 19 Oct 2020 04:35:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=lNMLub8xuNwacSkX7prd99PiOPz3ZsaWexy79M2Uk14=; b=ONyxZENuIkAr7rX1Q7Np8un1s4
 OdQEK9dHdSHuceYWbudntP9IvqMkDBGoEhwTr3N4eaoBleAof7bekz0o4DusnMITV4zQ96lI1QKDe
 6gYaOrS7JbqohPx8IaRk40FMwVaJh94AL6PEw4VnUEZglc+plszp56HRtp5nXAruKq5w=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kUQdG-0005Du-4P; Mon, 19 Oct 2020 10:35:08 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
 <87o8l1z7al.fsf@HIDDEN> <83k0vptdvq.fsf@HIDDEN>
 <87lfg4klay.fsf@HIDDEN> <83362bshl1.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAG1BMVEXW1NT7+vqaoLSC
 gX4RFiAaMWAuXLFnjNL///+RzdFuAAAAAWJLR0QIht6VegAAAAd0SU1FB+QKEwgMMM1iPfwAAAGm
 SURBVDjLtZTBTsMwDIadTBrXjCcIZiTXaYUXgLQPgJZyRZWaXKcA8evjtM02ISGQEN7Uuv7y20nc
 FOA723xjfwElrxJfAIiNmEuqjfhVKgXsKMG608j5fr1Hiah3Wt+gvrlUaJAgtRAaEMSPNVa3iNg0
 zR5nY3c3ge3B994550c/GbtPMwh9zBwMs41MHhcQkg3eR8oT8YcK+pDAjH1CYsss8RXkafARLAFS
 0VRgpxQoKSlZNAu46xMhK0wMEWQCqsCEhGAjmRBismVMBZEYpGlORKkUeZ5r3POaY0phAlQKLsXf
 nrXpMZWw5QlSGBcwGL321oZoU6aLWW1fVq9rH3MEXkgqCxmXGi84mEO3PnLLJcbzrLZdDN61JLhJ
 cDVcgDY+HJw/2kAAOfKsanEfPpzjrR+48RRYcFL02bmWE8kCOF63vfUjA3OUrDCjPzfKdZyqG64y
 IRrPfTqDdwa8NO7kWOJnwA9diLy7eYq3M7h3bXk4vSInsGoW2zfN7eztfnjbVTmK6st5rECpcgWh
 VPkvoASKL8pZ498fT239Hij4reI/wSfC5rg96R7ECQAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMC0x
 MC0xOVQwODoxMjo0OCswMDowMBv7BCQAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjAtMTAtMTlUMDg6
 MTI6NDgrMDA6MDBqpryYAAAAAElFTkSuQmCC
X-Now-Playing: Motorpsycho's _Roadwork vol. 5 (2)_: "Un Chien d'Espace"
Date: Mon, 19 Oct 2020 10:35:05 +0200
In-Reply-To: <83362bshl1.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 18 Oct
 2020 18:02:18 +0300")
Message-ID: <87tuuqfwau.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > It does -- for some
 value of "check". Opening a font and trying to > find a glyph for a character
 is expensive, so Emacs tries to avoid > that as much as possible. Instead,
 it uses less expensive "c [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, alan@HIDDEN, rpluim@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> It does -- for some value of "check".  Opening a font and trying to
> find a glyph for a character is expensive, so Emacs tries to avoid
> that as much as possible.  Instead, it uses less expensive "checks"
> that don't require actually opening the font.  The details are
> somewhat complicated (and I'm not sure I have a sufficiently clear
> picture of them, nor that we have someone on board who does), and the
> are to some extent font-backend dependent, but they have to do with
> the character's script, the script's characters in
> script-representative-chars, and system APIs for finding fonts that
> support those.  And the first problem with Emoji characters in this
> context is that their script is 'symbol', which doesn't allow us to
> assign an Emoji font to them as a script.

Ah, I see.  Thank you for the explanation.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 18 Oct 2020 15:02:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 18 11:02:21 2020
Received: from localhost ([127.0.0.1]:38842 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kUACT-0006N1-K6
	for submit <at> debbugs.gnu.org; Sun, 18 Oct 2020 11:02:21 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37082)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kUACS-0006Mp-D4
 for 44020 <at> debbugs.gnu.org; Sun, 18 Oct 2020 11:02:20 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44507)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kUACM-0005qU-Q9; Sun, 18 Oct 2020 11:02:14 -0400
Received: from [176.228.60.248] (port=1806 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kUACM-0005Y1-9O; Sun, 18 Oct 2020 11:02:14 -0400
Date: Sun, 18 Oct 2020 18:02:18 +0300
Message-Id: <83362bshl1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87lfg4klay.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 18 Oct 2020 10:09:09 +0200)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
 <87o8l1z7al.fsf@HIDDEN> <83k0vptdvq.fsf@HIDDEN> <87lfg4klay.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, alan@HIDDEN, rpluim@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: alan@HIDDEN,  rpluim@HIDDEN,  44020 <at> debbugs.gnu.org
> Date: Sun, 18 Oct 2020 10:09:09 +0200
> 
> > Are you sure?  What exactly makes sure Emacs won't have any problems
> > in those cases?  For starters, does Emacs really know that a given
> > character belongs to "Emoji"?  And if it does, does it know how to
> > filter fonts that support Emoji?
> 
> I thought that Emacs looped through all the fonts on the system and
> checked whether the font had coverage for the character we wanted to
> display?

It does -- for some value of "check".  Opening a font and trying to
find a glyph for a character is expensive, so Emacs tries to avoid
that as much as possible.  Instead, it uses less expensive "checks"
that don't require actually opening the font.  The details are
somewhat complicated (and I'm not sure I have a sufficiently clear
picture of them, nor that we have someone on board who does), and the
are to some extent font-backend dependent, but they have to do with
the character's script, the script's characters in
script-representative-chars, and system APIs for finding fonts that
support those.  And the first problem with Emoji characters in this
context is that their script is 'symbol', which doesn't allow us to
assign an Emoji font to them as a script.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 18 Oct 2020 08:09:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 18 04:09:29 2020
Received: from localhost ([127.0.0.1]:36116 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kU3kv-00067b-Hs
	for submit <at> debbugs.gnu.org; Sun, 18 Oct 2020 04:09:29 -0400
Received: from quimby.gnus.org ([95.216.78.240]:48612)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kU3kt-00067N-8j
 for 44020 <at> debbugs.gnu.org; Sun, 18 Oct 2020 04:09:27 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=1C9QPTVZhk/MZPepajr3/aGG4kz7dHbCaJkL+9mgW60=; b=RUN3q+0MHuWiAqazT3vjBzyI5d
 XIwHJRhVbPO+kZIEybpNPGUjNprU/3uTezasmrD4KmP8om2eXoCpwqpmUiPBhP29O9iptwLYpHYcF
 e3xCCHjtCAWCI8qy+hGaKDRCdrw9KGVIXrmtFdhIcY6TqSj7nDTf9N/4T85I+iZCwfwE=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kU3kc-0006EN-Vp; Sun, 18 Oct 2020 10:09:20 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
 <87o8l1z7al.fsf@HIDDEN> <83k0vptdvq.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAFVBMVEVDNUhYT2KHdIYf
 GCT0zK+oXWX////KAn60AAAAAWJLR0QGYWa4fQAAAAd0SU1FB+QKEgciIGgyBOwAAAG7SURBVDjL
 XZRBcsMgDEWlquzBHvY2SfakTA/Qjr13Oub+V6mEwNAyWWT0pP9BCAMAoHV1TZQSB6z8Iv+BC9yS
 LECnoFVMISRdkg14FTgXbqmhCBYHsAzAdXMX1g6InTq4UwMp4VhxXzqA0eP+TQ1E7CCE+zZ386sk
 CLhdQCuwgu/5OmIBVk4Z2GNu5qjnsKI3jQcEBQQqlkYgyaCdWUZQmkjFy7awycXcWqBS0uJ+24oU
 WydJqDuKHFeA5V7AaTfAnwr6BZd05/N2ASpAlPBV8qsUJQHISv5lNN5AqWPXPNd4ATMUQNHl/Lnl
 LkUVPH0+TB6kSDdFbz4TXlLcQQUoIJpt8KCyW5yRwXsHFitIi8/QAceoaGGyJhszANSOTOTM8e4H
 DwbiFGg1x3mMB+Qbj8iPZkV77gOQKREaA1q//QM8IPNHsHB5XyC4eXossfV2yxVMqyOew96RrHfq
 pgViCKuFP8AKwGd4vJz1/yr4UcXw+Fmduu/b0QDPFLKWU5PcgeMR4We+Kjh3HajyDig9xV7BVywf
 DlAgYk7c9/OQgUYlc5m2qQJTkgWgTnpEnsM9v7wagzyoOtEK8i+W2o66dNtRxAAAACV0RVh0ZGF0
 ZTpjcmVhdGUAMjAyMC0xMC0xOFQwNzozNDozMiswMDowMGkk31EAAAAldEVYdGRhdGU6bW9kaWZ5
 ADIwMjAtMTAtMThUMDc6MzQ6MzIrMDA6MDAYeWftAAAAAElFTkSuQmCC
X-Now-Playing: Rocket To The Sky's _Cigars_: "Cigars"
Date: Sun, 18 Oct 2020 10:09:09 +0200
In-Reply-To: <83k0vptdvq.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 17 Oct
 2020 12:12:25 +0300")
Message-ID: <87lfg4klay.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> On the third hand,
 since it's preinstalled, Emacs doesn't need to >> mention it, because it's
 always there, and Emacs won't have problems >> displaying the characters
 it offers. > > Are you sure? W [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, alan@HIDDEN, rpluim@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> On the third hand, since it's preinstalled, Emacs doesn't need to
>> mention it, because it's always there, and Emacs won't have problems
>> displaying the characters it offers.
>
> Are you sure?  What exactly makes sure Emacs won't have any problems
> in those cases?  For starters, does Emacs really know that a given
> character belongs to "Emoji"?  And if it does, does it know how to
> filter fonts that support Emoji?

I thought that Emacs looped through all the fonts on the system and
checked whether the font had coverage for the character we wanted to
display?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 17 Oct 2020 15:51:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 17 11:51:47 2020
Received: from localhost ([127.0.0.1]:35362 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kToUl-0003VL-HE
	for submit <at> debbugs.gnu.org; Sat, 17 Oct 2020 11:51:47 -0400
Received: from idiocy.org ([217.169.17.33]:50375 helo=breton.holly.idiocy.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alan@HIDDEN>) id 1kToUj-0003V7-Oc
 for 44020 <at> debbugs.gnu.org; Sat, 17 Oct 2020 11:51:46 -0400
Received: by breton.holly.idiocy.org (Postfix, from userid 501)
 id AC5A5202610715; Sat, 17 Oct 2020 16:51:39 +0100 (BST)
Date: Sat, 17 Oct 2020 16:51:39 +0100
From: Alan Third <alan@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>, Robert Pluim <rpluim@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>, 44020 <at> debbugs.gnu.org
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
Message-ID: <20201017155139.GD1166@HIDDEN>
Mail-Followup-To: Alan Third <alan@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, Robert Pluim <rpluim@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>, 44020 <at> debbugs.gnu.org
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
 <87o8l1z7al.fsf@HIDDEN>
 <20201017152758.GC1166@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20201017152758.GC1166@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Oct 17, 2020 at 04:27:58PM +0100, Alan Third wrote:
> 
> Emacs almost never finds Apple Color Emoji without help. I've no idea
> why.

Sorry, I've just realised I'm going round in circles as this is
exactly what Robert's working on. Ignore me, please. :)

-- 
Alan Third




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 17 Oct 2020 15:28:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 17 11:28:07 2020
Received: from localhost ([127.0.0.1]:35343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTo7r-0002vZ-53
	for submit <at> debbugs.gnu.org; Sat, 17 Oct 2020 11:28:07 -0400
Received: from idiocy.org ([217.169.17.33]:50346 helo=breton.holly.idiocy.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alan@HIDDEN>) id 1kTo7o-0002v0-UC
 for 44020 <at> debbugs.gnu.org; Sat, 17 Oct 2020 11:28:05 -0400
Received: by breton.holly.idiocy.org (Postfix, from userid 501)
 id CB5302026103B2; Sat, 17 Oct 2020 16:27:58 +0100 (BST)
Date: Sat, 17 Oct 2020 16:27:58 +0100
From: Alan Third <alan@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
Message-ID: <20201017152758.GC1166@HIDDEN>
Mail-Followup-To: Alan Third <alan@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, Robert Pluim <rpluim@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>, 44020 <at> debbugs.gnu.org
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
 <87o8l1z7al.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87o8l1z7al.fsf@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, Robert Pluim <rpluim@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Oct 17, 2020 at 08:38:10AM +0200, Lars Ingebrigtsen wrote:
> Alan Third <alan@HIDDEN> writes:
> 
> > On the other hand it comes preinstalled, it only works on Apple
> > devices, and Noto Color Emoji doesn't work on Apple devices. I'm not
> > sure we'd really be "promoting" it.
> 
> On the third hand, since it's preinstalled, Emacs doesn't need to
> mention it, because it's always there, and Emacs won't have problems
> displaying the characters it offers.

Even once I remove this code:

modified   src/macfont.m
@@ -2414,11 +2414,6 @@ So we use CTFontDescriptorCreateMatchingFontDescriptor (no
                   != (spacing >= FONT_SPACING_MONO)))
             continue;
 
-          /* Don't use a color bitmap font unless its family is
-             explicitly specified.  */
-          if ((sym_traits & kCTFontTraitColorGlyphs) && NILP (family))
-            continue;
-
           if (j > 0
               && !macfont_supports_charset_and_languages_p (desc, charset,
                                                             chars, languages))

Emacs almost never finds Apple Color Emoji without help. I've no idea
why.

For some reason it finds the font for BLACK DOWN-POINTING DOUBLE
TRIANGLE, but not SMILING FACE WITH SMILING EYES unless the former is
already in the document.

Should this Just Work?

BTW, there is code in ns-win.el that plays with the default fontset on
Macs which may be breaking our rules.
-- 
Alan Third




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 17 Oct 2020 09:12:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 17 05:12:32 2020
Received: from localhost ([127.0.0.1]:33316 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTiGO-0005fQ-J5
	for submit <at> debbugs.gnu.org; Sat, 17 Oct 2020 05:12:32 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46884)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kTiGM-0005fB-Ml
 for 44020 <at> debbugs.gnu.org; Sat, 17 Oct 2020 05:12:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53049)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kTiGG-00055A-LS; Sat, 17 Oct 2020 05:12:25 -0400
Received: from [176.228.60.248] (port=2890 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kTiGG-0008Lv-06; Sat, 17 Oct 2020 05:12:24 -0400
Date: Sat, 17 Oct 2020 12:12:25 +0300
Message-Id: <83k0vptdvq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87o8l1z7al.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sat, 
 17 Oct 2020 08:38:10 +0200)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
 <87o8l1z7al.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, alan@HIDDEN, rpluim@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Robert Pluim <rpluim@HIDDEN>,  Eli Zaretskii <eliz@HIDDEN>,
>   44020 <at> debbugs.gnu.org
> Date: Sat, 17 Oct 2020 08:38:10 +0200
> 
> Alan Third <alan@HIDDEN> writes:
> 
> > On the other hand it comes preinstalled, it only works on Apple
> > devices, and Noto Color Emoji doesn't work on Apple devices. I'm not
> > sure we'd really be "promoting" it.
> 
> On the third hand, since it's preinstalled, Emacs doesn't need to
> mention it, because it's always there, and Emacs won't have problems
> displaying the characters it offers.

Are you sure?  What exactly makes sure Emacs won't have any problems
in those cases?  For starters, does Emacs really know that a given
character belongs to "Emoji"?  And if it does, does it know how to
filter fonts that support Emoji?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 17 Oct 2020 06:44:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 17 02:44:52 2020
Received: from localhost ([127.0.0.1]:33110 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTfxT-00044W-Ue
	for submit <at> debbugs.gnu.org; Sat, 17 Oct 2020 02:44:52 -0400
Received: from eggs.gnu.org ([209.51.188.92]:54900)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kTfxR-00044K-Td
 for 44020 <at> debbugs.gnu.org; Sat, 17 Oct 2020 02:44:50 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51664)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kTfxM-0002eV-Bl; Sat, 17 Oct 2020 02:44:44 -0400
Received: from [176.228.60.248] (port=1607 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kTfxL-00062R-Ks; Sat, 17 Oct 2020 02:44:44 -0400
Date: Sat, 17 Oct 2020 09:44:44 +0300
Message-Id: <835z79uzab.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Alan Third <alan@HIDDEN>
In-Reply-To: <20201016193041.GA1166@HIDDEN> (message from
 Alan Third on Fri, 16 Oct 2020 20:30:41 +0100)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN> <20201016193041.GA1166@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, rpluim@HIDDEN, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 16 Oct 2020 20:30:41 +0100
> From: Alan Third <alan@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, 44020 <at> debbugs.gnu.org, larsi@HIDDEN
> 
> On Fri, Oct 16, 2020 at 12:38:18PM +0200, Robert Pluim wrote:
> > >>>>> On Fri, 16 Oct 2020 13:26:42 +0300, Eli Zaretskii <eliz@HIDDEN> said:
> > 
> >     Eli> Also, Noto Color Emoji has a free license, so it's okay for it to be
> >     Eli> in fontset.el, but it is not clear to me whether Apple Color Emoji is
> >     Eli> distributed under a free license.
> > 
> > Itʼs marked 'Copyright Apple 2011-2016' in the macOS font
> > selector. And Apple appear to be both sensitive and litigious about
> > it, so probably best not to promote it.
> 
> On the other hand it comes preinstalled, it only works on Apple
> devices, and Noto Color Emoji doesn't work on Apple devices. I'm not
> sure we'd really be "promoting" it.
> 
> IIRC Windows comes with Segoe UI Emoji preinstalled too.

Both are true, but AFAIK our policy until now was not to mention such
fonts in fontset.el.

Emoji is just one example, btw.  At least for MS-Windows, the latest
versions come with many good fonts that cover most of the scripts.  So
if the restriction to avoid mentioning proprietary fonts in fontset.el
could be lifted, we could produce a very capable and complete fontset
for MS-Windows.  I wouldn't be surprised if the same situation didn't
exist on macOS.  Not sure how things are on GNU/Linux, and what are
the differences between the distros in this respect.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 17 Oct 2020 06:38:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 17 02:38:22 2020
Received: from localhost ([127.0.0.1]:33102 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTfrB-0003vS-VB
	for submit <at> debbugs.gnu.org; Sat, 17 Oct 2020 02:38:22 -0400
Received: from quimby.gnus.org ([95.216.78.240]:36050)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kTfrA-0003vD-Cy
 for 44020 <at> debbugs.gnu.org; Sat, 17 Oct 2020 02:38:20 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=SWRair7ac2RmmnTG4d8HKMenF+4i2M+g1ZazwY121Xc=; b=iinWq7Fj98UluqGp4BA4wdaU24
 0fLL6AFY3ukkLdgTGkpqw1ZJMVcNkD1BdZ1M1xtv37O2Qx1mAX+g3NIo94kEJ00vN1+LqWliRg/U2
 rEkIAQrZ+LyL7unHE5pfpZVpW6nkZHX1G6lQlbKO9nXuGIVkXqGuW1KDZnTGnqGop/wY=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kTfr1-00005s-IN; Sat, 17 Oct 2020 08:38:14 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Alan Third <alan@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
 <20201016193041.GA1166@HIDDEN>
X-Now-Playing: Various's _1-8 Split Series_: "Ad Vanz, Gescom - Viral"
Date: Sat, 17 Oct 2020 08:38:10 +0200
In-Reply-To: <20201016193041.GA1166@HIDDEN> (Alan Third's
 message of "Fri, 16 Oct 2020 20:30:41 +0100")
Message-ID: <87o8l1z7al.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Alan Third <alan@HIDDEN> writes: > On the other hand it
 comes preinstalled, it only works on Apple > devices, and Noto Color Emoji
 doesn't work on Apple devices. I'm not > sure we'd really be "promoting"
 it. Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, Robert Pluim <rpluim@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Alan Third <alan@HIDDEN> writes:

> On the other hand it comes preinstalled, it only works on Apple
> devices, and Noto Color Emoji doesn't work on Apple devices. I'm not
> sure we'd really be "promoting" it.

On the third hand, since it's preinstalled, Emacs doesn't need to
mention it, because it's always there, and Emacs won't have problems
displaying the characters it offers.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 16 Oct 2020 19:30:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 16 15:30:51 2020
Received: from localhost ([127.0.0.1]:60925 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTVRD-0004XM-Fk
	for submit <at> debbugs.gnu.org; Fri, 16 Oct 2020 15:30:51 -0400
Received: from idiocy.org ([217.169.17.33]:49808 helo=breton.holly.idiocy.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alan@HIDDEN>) id 1kTVRA-0004X8-R9
 for 44020 <at> debbugs.gnu.org; Fri, 16 Oct 2020 15:30:50 -0400
Received: by breton.holly.idiocy.org (Postfix, from userid 501)
 id 0BA8120260E48B; Fri, 16 Oct 2020 20:30:41 +0100 (BST)
Date: Fri, 16 Oct 2020 20:30:41 +0100
From: Alan Third <alan@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
Message-ID: <20201016193041.GA1166@HIDDEN>
Mail-Followup-To: Alan Third <alan@HIDDEN>,
 Robert Pluim <rpluim@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 44020 <at> debbugs.gnu.org, larsi@HIDDEN
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
 <m2d01ih2w5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <m2d01ih2w5.fsf@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, Oct 16, 2020 at 12:38:18PM +0200, Robert Pluim wrote:
> >>>>> On Fri, 16 Oct 2020 13:26:42 +0300, Eli Zaretskii <eliz@HIDDEN> said:
> 
>     Eli> Also, Noto Color Emoji has a free license, so it's okay for it to be
>     Eli> in fontset.el, but it is not clear to me whether Apple Color Emoji is
>     Eli> distributed under a free license.
> 
> Itʼs marked 'Copyright Apple 2011-2016' in the macOS font
> selector. And Apple appear to be both sensitive and litigious about
> it, so probably best not to promote it.

On the other hand it comes preinstalled, it only works on Apple
devices, and Noto Color Emoji doesn't work on Apple devices. I'm not
sure we'd really be "promoting" it.

IIRC Windows comes with Segoe UI Emoji preinstalled too.
-- 
Alan Third




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 16 Oct 2020 14:49:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 16 10:49:55 2020
Received: from localhost ([127.0.0.1]:60470 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTR3L-0005kc-Eu
	for submit <at> debbugs.gnu.org; Fri, 16 Oct 2020 10:49:55 -0400
Received: from quimby.gnus.org ([95.216.78.240]:57128)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kTR3J-0005kP-BQ
 for 44020 <at> debbugs.gnu.org; Fri, 16 Oct 2020 10:49:53 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=7Wq1wJkOzuHOOxjFecVIeD8iiqF75LAIM9MltyabT00=; b=NsCI5w1RsDrkbdL6rqooN7IZIi
 THfoavFWOYY/arMipE4wWyi6vmmpMTojh8p/YpnZRDl8ReJmFP9WaP1SNTIgE+d1NA9R1IURQiE3N
 zqBK8fc3BLXfNcfE4u64XZvPtK/BZxIFusz06Qao0jCDF99SvqeH9ZTqAJtjZsrxm44U=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kTR3A-0004P7-Qp; Fri, 16 Oct 2020 16:49:47 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAMFBMVEX+/v7s6ejj393R
 zMtnXVuyrKssIB9EOTeDeHYzJyUkGRgaEBDGvbhQPzuelZL///8RPH+VAAAAAWJLR0QPGLoA2QAA
 AAd0SU1FB+QKEA4lDl59bOAAAACTSURBVDjLY2AYBUMLMCoIMxhgk2B2CDMoYW7ClGB1iFRcwrLZ
 5AAWCaUtLLmZjpgSYUpLni+bYYBFh3Lmqi2Y9vNceGW3O30qFlcVvKrebpqHRWKO99odfOswJZhm
 7n66hRWLDtZdt4238JRgSrzeah2UwnwF04oplzQfTmeIwwxDAyUmARcBXCHMMAoGGgjhEAcA9Msm
 KaubwYcAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjAtMTAtMTZUMTQ6Mzc6MTQrMDA6MDCjoS0GAAAA
 JXRFWHRkYXRlOm1vZGlmeQAyMDIwLTEwLTE2VDE0OjM3OjE0KzAwOjAw0vyVugAAAABJRU5ErkJg
 gg==
X-Now-Playing: Lamb's _5_: "Back to Beginning"
Date: Fri, 16 Oct 2020 16:49:43 +0200
In-Reply-To: <m2o8l2inwf.fsf@HIDDEN> (Robert Pluim's message of "Fri, 16
 Oct 2020 10:19:12 +0200")
Message-ID: <87imba4454.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Robert Pluim <rpluim@HIDDEN> writes: > Iʼll see if I can
    clean this up this weekend and throw it on a branch. Looking forward to it.
    :-) And I agree with Eli; doing it on the trunk would be fine. 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Robert Pluim <rpluim@HIDDEN> writes:

> I=CA=BCll see if I can clean this up this weekend and throw it on a branc=
h.

Looking forward to it.  :-)  And I agree with Eli; doing it on the trunk
would be fine.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 16 Oct 2020 10:49:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 16 06:49:55 2020
Received: from localhost ([127.0.0.1]:57840 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTNJ5-0000qr-LS
	for submit <at> debbugs.gnu.org; Fri, 16 Oct 2020 06:49:55 -0400
Received: from eggs.gnu.org ([209.51.188.92]:36214)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kTNJ4-0000qf-BN
 for 44020 <at> debbugs.gnu.org; Fri, 16 Oct 2020 06:49:54 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52159)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kTNIy-00025j-Uj; Fri, 16 Oct 2020 06:49:48 -0400
Received: from [176.228.60.248] (port=3921 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kTNIy-000475-4p; Fri, 16 Oct 2020 06:49:48 -0400
Date: Fri, 16 Oct 2020 13:49:46 +0300
Message-Id: <83362ewilx.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-Reply-To: <m2d01ih2w5.fsf@HIDDEN> (message from Robert Pluim on Fri, 16
 Oct 2020 12:38:18 +0200)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN> <m2d01ih2w5.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Robert Pluim <rpluim@HIDDEN>
> Cc: larsi@HIDDEN,  44020 <at> debbugs.gnu.org
> Date: Fri, 16 Oct 2020 12:38:18 +0200
> 
>     >> 1. Deciding what fonts we should use for emoji. We can get a lot of
>     >> good results by adding appropriate 'set-fontset-font' calls to
>     >> emacs, independently of any other work (I also wonder if we should
>     >> change the default of use-default-font-for-symbols, given the
>     >> proliferation of both emoji and fonts dedicated to displaying them)
>     >> 
>     >> 2. Extract the emoji sequences from the Unicode data files and assign
>     >> them to a new 'emoji' script. Be prepared to choose your favourite
>     >> bikeshed colour.
>     >> 
>     >> 3. Add the appropriate entries to composition-function-table so that
>     >> the various multi-codepoint emoji sequences have a chance to be
>     >> rendered correctly, whether by HarfBuzz or the Apple thing whose
>     >> name I forget.
>     >> 
>     >> For [1], I think "Noto Color Emoji" and "Apple Color Emoji" would be a
>     >> good start.
> 
>     Eli> I agree, but [1] depends on [2], because set-fontset-font needs to
>     Eli> know the script.
> 
> set-fontset-font with a TARGET covering the emoji codepoints in
> question, I meant. Youʼre right itʼs probably cleaner to do both at
> the same time.

Yes, because using the codepoints will mean more maintenance in the
future, as more Emoji blocks are added (and they will be, quite
certainly).

> 
>     Eli> Also, Noto Color Emoji has a free license, so it's okay for it to be
>     Eli> in fontset.el, but it is not clear to me whether Apple Color Emoji is
>     Eli> distributed under a free license.
> 
> Itʼs marked 'Copyright Apple 2011-2016' in the macOS font
> selector. And Apple appear to be both sensitive and litigious about
> it, so probably best not to promote it.

Right.  People will have to do that on their own, if they don't want
to install a free font.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 16 Oct 2020 10:38:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 16 06:38:27 2020
Received: from localhost ([127.0.0.1]:57803 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTN7z-0000Xq-7P
	for submit <at> debbugs.gnu.org; Fri, 16 Oct 2020 06:38:27 -0400
Received: from mail-wm1-f46.google.com ([209.85.128.46]:35915)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1kTN7y-0000Xe-Bd
 for 44020 <at> debbugs.gnu.org; Fri, 16 Oct 2020 06:38:26 -0400
Received: by mail-wm1-f46.google.com with SMTP id e2so2330664wme.1
 for <44020 <at> debbugs.gnu.org>; Fri, 16 Oct 2020 03:38:26 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=c2I1hXZm/iRj7541Ijc6lEoBqcn+U70cqGFx5FvtWHw=;
 b=V21jurAT+I6TU2N/W+Mr9yeMDw5RnOZx8YeDhpfAl8jZ+00Eu9nyQcM2WtJt9rNcyz
 7ArccqNE12ALJtUqFJ0CdxqmarCUXtXWXMUwlPx/hc1WrKhkMtt6h1YBXUElm8Z+vosJ
 CSwWJ+SXYjiesNEIBHW2CLyGKU7ZrWqbLJLqicQVZ2qugnnps4HfAWx6rHykSU4q9ADC
 msyew52O2J36DaRM1wLrym2aymFo5HzEKuDoAhEMr3Ui8yaET4eg0psztXpn0uG0bD5c
 2s7v3MnPxEip6Vgpxzj59AhSCUYD1Hqg6iEWzlEbg3QujrlJ4AiEl7pOX7ksmS6QlCvR
 hD+g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=c2I1hXZm/iRj7541Ijc6lEoBqcn+U70cqGFx5FvtWHw=;
 b=nD66KR/6FiWB0NqxxbjXEobA96Uo9uvmaXwPtU4LRWsndM1gchjHGOpWliEShcAPnX
 ynAJg24zctCVn65rQJK1GgELbPd/l9jl0upEE0VaMslVR3DIm5Tn0bVoFadORJXHuF50
 /NHuGYzusbO2LrF7XauXCDKDs9zfoR2N/WvjUA4i9H7ML4/iiU5KGa3hkXKAc+LyOPZR
 pQYGBb4Lr497QiFRRGHy+OI8ZBZP7qyA2n7i4cAvMt5AuIVZgHXPrl+Kq2HeZWSdn4l3
 I78u5uqn4GSpZ+OHCEJ8SXBmQEk9vzMSjn1Y0TVIO0Gx/pYidps1FP+L5d4xzLrBvNwy
 OZfA==
X-Gm-Message-State: AOAM533mCUgacPoxKeZ0Fgf8BgNos6uPbNjUrMfSQTKuomPFdUvHZ/yf
 fMDbZXlhu45rnXbDez07NuK+UzT1sVM=
X-Google-Smtp-Source: ABdhPJwqFfcUusLbvSh8owtxbKM6TVLF75mqWBd0qfCHD2hX3O+yn1jLuSoHlVvjITO7pEJoP/5kfQ==
X-Received: by 2002:a05:600c:247:: with SMTP id 7mr3036654wmj.7.1602844699974; 
 Fri, 16 Oct 2020 03:38:19 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:9474:cfb2:b9a9:23d4])
 by smtp.gmail.com with ESMTPSA id h16sm3039316wre.87.2020.10.16.03.38.18
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 16 Oct 2020 03:38:18 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN> <83a6wmwjod.fsf@HIDDEN>
Date: Fri, 16 Oct 2020 12:38:18 +0200
In-Reply-To: <83a6wmwjod.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 16 Oct
 2020 13:26:42 +0300")
Message-ID: <m2d01ih2w5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Fri, 16 Oct 2020 13:26:42 +0300, Eli Zaretskii <eliz@HIDDEN> said:

    >> From: Robert Pluim <rpluim@HIDDEN>
    >> Cc: Lars Ingebrigtsen <larsi@HIDDEN>,  44020 <at> debbugs.gnu.org
    >> Date: Fri, 16 Oct 2020 10:19:12 +0200
    >>=20
    >> 1. Deciding what fonts we should use for emoji. We can get a lot of
    >> good results by adding appropriate 'set-fontset-font' calls to
    >> emacs, independently of any other work (I also wonder if we should
    >> change the default of use-default-font-for-symbols, given the
    >> proliferation of both emoji and fonts dedicated to displaying them)
    >>=20
    >> 2. Extract the emoji sequences from the Unicode data files and assign
    >> them to a new 'emoji' script. Be prepared to choose your favourite
    >> bikeshed colour.
    >>=20
    >> 3. Add the appropriate entries to composition-function-table so that
    >> the various multi-codepoint emoji sequences have a chance to be
    >> rendered correctly, whether by HarfBuzz or the Apple thing whose
    >> name I forget.
    >>=20
    >> For [1], I think "Noto Color Emoji" and "Apple Color Emoji" would be=
 a
    >> good start.

    Eli> I agree, but [1] depends on [2], because set-fontset-font needs to
    Eli> know the script.

set-fontset-font with a TARGET covering the emoji codepoints in
question, I meant. You=CA=BCre right it=CA=BCs probably cleaner to do both =
at
the same time.

    Eli> Also, Noto Color Emoji has a free license, so it's okay for it to =
be
    Eli> in fontset.el, but it is not clear to me whether Apple Color Emoji=
 is
    Eli> distributed under a free license.

It=CA=BCs marked 'Copyright Apple 2011-2016' in the macOS font
selector. And Apple appear to be both sensitive and litigious about
it, so probably best not to promote it.

    >> For [2], I think that was finished, except that Eli then updated Ema=
cs
    >> to the next version of Unicode, and I haven't adjusted yet.

    Eli> "Finished", in the sense that it is in Emacs already?

No, finished as in "it works for me on my mac and GNU/Linux boxes" =F0=9F=
=99=82

As I said, it needs adjusting to the latest Unicode update.

    >> I=CA=BCll see if I can clean this up this weekend and throw it on a =
branch.

    Eli> Thanks.

    Eli> FWIW, I think this is good enough to land on master directly, I se=
e no
    Eli> need for a feature branch.

OK.

Robert
--=20




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 16 Oct 2020 10:26:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 16 06:26:52 2020
Received: from localhost ([127.0.0.1]:57743 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTMwm-0000DC-MD
	for submit <at> debbugs.gnu.org; Fri, 16 Oct 2020 06:26:52 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50396)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kTMwk-0000Cz-Bw
 for 44020 <at> debbugs.gnu.org; Fri, 16 Oct 2020 06:26:50 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50128)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kTMwf-0005TT-28; Fri, 16 Oct 2020 06:26:45 -0400
Received: from [176.228.60.248] (port=2498 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kTMwe-0006mV-Ay; Fri, 16 Oct 2020 06:26:44 -0400
Date: Fri, 16 Oct 2020 13:26:42 +0300
Message-Id: <83a6wmwjod.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-Reply-To: <m2o8l2inwf.fsf@HIDDEN> (message from Robert Pluim on Fri, 16
 Oct 2020 10:19:12 +0200)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
 <m2o8l2inwf.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Robert Pluim <rpluim@HIDDEN>
> Cc: Lars Ingebrigtsen <larsi@HIDDEN>,  44020 <at> debbugs.gnu.org
> Date: Fri, 16 Oct 2020 10:19:12 +0200
> 
> 1. Deciding what fonts we should use for emoji. We can get a lot of
>    good results by adding appropriate 'set-fontset-font' calls to
>    emacs, independently of any other work (I also wonder if we should
>    change the default of use-default-font-for-symbols, given the
>    proliferation of both emoji and fonts dedicated to displaying them)
> 
> 2. Extract the emoji sequences from the Unicode data files and assign
>    them to a new 'emoji' script. Be prepared to choose your favourite
>    bikeshed colour.
> 
> 3. Add the appropriate entries to composition-function-table so that
>    the various multi-codepoint emoji sequences have a chance to be
>    rendered correctly, whether by HarfBuzz or the Apple thing whose
>    name I forget.
> 
> For [1], I think "Noto Color Emoji" and "Apple Color Emoji" would be a
> good start.

I agree, but [1] depends on [2], because set-fontset-font needs to
know the script.

Also, Noto Color Emoji has a free license, so it's okay for it to be
in fontset.el, but it is not clear to me whether Apple Color Emoji is
distributed under a free license.

> For [2], I think that was finished, except that Eli then updated Emacs
> to the next version of Unicode, and I haven't adjusted yet.

"Finished", in the sense that it is in Emacs already?

> Iʼll see if I can clean this up this weekend and throw it on a branch.

Thanks.

FWIW, I think this is good enough to land on master directly, I see no
need for a feature branch.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 16 Oct 2020 08:19:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 16 04:19:22 2020
Received: from localhost ([127.0.0.1]:57563 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kTKxO-0005JH-FW
	for submit <at> debbugs.gnu.org; Fri, 16 Oct 2020 04:19:22 -0400
Received: from mail-wm1-f51.google.com ([209.85.128.51]:37748)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1kTKxM-0005J4-Np
 for 44020 <at> debbugs.gnu.org; Fri, 16 Oct 2020 04:19:21 -0400
Received: by mail-wm1-f51.google.com with SMTP id j136so1893510wmj.2
 for <44020 <at> debbugs.gnu.org>; Fri, 16 Oct 2020 01:19:20 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=Z9z0yazu9PgFoPyi0qkbq4PkSXgBflL19RG/XFNk2nI=;
 b=H+1L2n4di22pJmzjiyKwdKJvUdgW3xqlF7Er9KM72Zb+dQsEnvK6HV0F+CoguGQaiE
 8wP0OeuRw3f7Ve39jcIBt7ttXRuR1dTtW8/6bVD8OSymatwNkjdsjANQ3NuQbK8ygi40
 aMFRKjhplq4RbWIXeJUixQHlmrLc0nks4cKeiCeK1+3XdGxWDT+75vz25iP+WWFnCLpK
 mZTE4oOTyfJUPkjoEaE0iIs76JDQbqV8ufUi3SFs1+nyXfHJOViuNpuW7W0ZoPgHmbnA
 cuIXmzbgHLyl2wdPhEseSCFHT7sk7d6O0gGYx2bPfoSXecGerNP3mq7rsT6k6yKksL6H
 4tlA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=Z9z0yazu9PgFoPyi0qkbq4PkSXgBflL19RG/XFNk2nI=;
 b=sfMvvyDTYoT1IFIawcxZP6JLzIfMMrPdUdcctcA+eqcJAH1XV9eArZ1lig7BsH797Z
 Ds0jvjCkCYALHkSuzYkDbHjoXnQqEUrjnxW0zWWmAOku4jRVdu8zHD7kqKXbnqUCXedU
 JDIvZ22KXau3ncEiJb/ksUAaIerFivm9VqJ6JVR6EnEklXLMVhm7uR3cuECFqKTNzxs1
 z20RYLDTbzZ/aEE46Zqai84DIDrnT2b5N0D8l0NctEJ8+1pzeC0d+TrhmiZ5ahAk+DKQ
 nKpNBBA4QFl0n7qTM7DffW/0vKZIZmha5oYfIuP+8E55BBXHK67T22DvFm7j6R2mRAIr
 QlOQ==
X-Gm-Message-State: AOAM53178nrKkt++ADbOjLpKZq+YLNu6X2l5vEpIpJL9T6Q/TPPZVbU5
 Frsw8gPCUrXz6oTvRAjt4jGf5ccPktQ=
X-Google-Smtp-Source: ABdhPJwXM9DV5ZPYaAb+o3MvuSFNxtAwZAyb/SQoaDxYKO487DrUiyhsvOwLAKcnx6g7+f+Ku+OGAA==
X-Received: by 2002:a1c:7c09:: with SMTP id x9mr2622405wmc.181.1602836354234; 
 Fri, 16 Oct 2020 01:19:14 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:9474:cfb2:b9a9:23d4])
 by smtp.gmail.com with ESMTPSA id j17sm2367906wrw.68.2020.10.16.01.19.13
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 16 Oct 2020 01:19:13 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN> <83tuuvwcd8.fsf@HIDDEN>
Date: Fri, 16 Oct 2020 10:19:12 +0200
In-Reply-To: <83tuuvwcd8.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 15 Oct
 2020 21:52:19 +0300")
Message-ID: <m2o8l2inwf.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Thu, 15 Oct 2020 21:52:19 +0300, Eli Zaretskii <eliz@HIDDEN> said:

    >> From: Lars Ingebrigtsen <larsi@HIDDEN>
    >> Date: Thu, 15 Oct 2020 20:10:44 +0200
    >>=20
    >>=20
    >> If I start "emacs -Q" and load a file with this character:
    >>=20
    >> =F0=9F=8E=89
    >>=20
    >> Emacs shows that as a black-and-white symbol using the Symbola font.
    >>=20
    >> If I then say
    >>=20
    >> (set-fontset-font t 'symbol "Noto Color Emoji")
    >> (set-fontset-font t 'symbol "Symbola" nil 'append)
    >>=20
    >> I get a colourful party popper.
    >>=20
    >> It'd be nice if this worked out of the box.

    Eli> AFAIR, Robert Pluim worked on better support for Emoji display; th=
at
    Eli> needs a few more tweaks and importing one more file from the UCD, =
to
    Eli> support Emoji sequences.  I hope this will be ready some time soon.
    Eli> Robert?

There=CA=BCs three parts to that:

1. Deciding what fonts we should use for emoji. We can get a lot of
   good results by adding appropriate 'set-fontset-font' calls to
   emacs, independently of any other work (I also wonder if we should
   change the default of use-default-font-for-symbols, given the
   proliferation of both emoji and fonts dedicated to displaying them)

2. Extract the emoji sequences from the Unicode data files and assign
   them to a new 'emoji' script. Be prepared to choose your favourite
   bikeshed colour.

3. Add the appropriate entries to composition-function-table so that
   the various multi-codepoint emoji sequences have a chance to be
   rendered correctly, whether by HarfBuzz or the Apple thing whose
   name I forget.

For [1], I think "Noto Color Emoji" and "Apple Color Emoji" would be a
good start.

For [2], I think that was finished, except that Eli then updated Emacs
to the next version of Unicode, and I haven't adjusted yet.

[3] is done for the cases that composition can currently handle. I
recall that there are sequences that require composition to do
lookback, which I think YAMAMOTO-san has patches for, but they've not
been submitted to Emacs (a quick perusal of my notes says this is for
keycap emojis, so I guess that=CA=BCs a minor nit).

Oh, and there was a complication with enabling this by default on
macOS that I don=CA=BCt fully understand yet. I=CA=BCll reread the history.

I=CA=BCll see if I can clean this up this weekend and throw it on a branch.

Robert
--=20




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at 44020 <at> debbugs.gnu.org:


Received: (at 44020) by debbugs.gnu.org; 15 Oct 2020 18:52:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 15 14:52:30 2020
Received: from localhost ([127.0.0.1]:56550 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kT8MX-00061P-Vn
	for submit <at> debbugs.gnu.org; Thu, 15 Oct 2020 14:52:30 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37840)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kT8MX-00061E-7v
 for 44020 <at> debbugs.gnu.org; Thu, 15 Oct 2020 14:52:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56311)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kT8MR-0008M9-Tg; Thu, 15 Oct 2020 14:52:23 -0400
Received: from [176.228.60.248] (port=4554 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kT8MR-0007m6-8x; Thu, 15 Oct 2020 14:52:23 -0400
Date: Thu, 15 Oct 2020 21:52:19 +0300
Message-Id: <83tuuvwcd8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>, Robert Pluim <rpluim@HIDDEN>
In-Reply-To: <87tuuvtl5n.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 15 Oct 2020 20:10:44 +0200)
Subject: Re: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?
References: <87tuuvtl5n.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44020
Cc: 44020 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Date: Thu, 15 Oct 2020 20:10:44 +0200
> 
> 
> If I start "emacs -Q" and load a file with this character:
> 
> 🎉
> 
> Emacs shows that as a black-and-white symbol using the Symbola font.
> 
> If I then say
> 
> (set-fontset-font t 'symbol "Noto Color Emoji")
> (set-fontset-font t 'symbol "Symbola" nil 'append)
> 
> I get a colourful party popper.
> 
> It'd be nice if this worked out of the box.

AFAIR, Robert Pluim worked on better support for Emoji display; that
needs a few more tweaks and importing one more file from the UCD, to
support Emoji sequences.  I hope this will be ready some time soon.
Robert?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 15 Oct 2020 18:11:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 15 14:11:13 2020
Received: from localhost ([127.0.0.1]:56514 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kT7iR-00051E-6k
	for submit <at> debbugs.gnu.org; Thu, 15 Oct 2020 14:11:13 -0400
Received: from lists.gnu.org ([209.51.188.17]:59746)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kT7iP-00050w-PY
 for submit <at> debbugs.gnu.org; Thu, 15 Oct 2020 14:11:02 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:34734)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <larsi@HIDDEN>) id 1kT7iM-00072p-Dn
 for bug-gnu-emacs@HIDDEN; Thu, 15 Oct 2020 14:11:01 -0400
Received: from quimby.gnus.org ([2a01:4f9:2b:f0f::2]:35440)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <larsi@HIDDEN>) id 1kT7iJ-00030B-GJ
 for bug-gnu-emacs@HIDDEN; Thu, 15 Oct 2020 14:10:58 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :Date:Subject:To:From:Sender:Reply-To:Cc:Content-ID:Content-Description:
 Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:
 In-Reply-To:References:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=/ZN/32ybwxd+tef6HV2XHMz8SWl/YqmgLbLwMZNXnBY=; b=huK2Jkk7gJdnshGI6CbrCh3Dsd
 Bum6CAlPAFqx/8UeYzMZ85LTtzEiJ/iQP18/ZkYVsowopiTQKkt/JYhkTlTKoI/9AT5SnMryjrt7q
 XwmKOeKf0E/ckQnfluNbvyguIow4jmaixhkYXFIoMu+KgqYMBIaHyfDshdPbuAeNuDtQ=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>) id 1kT7i9-0007TK-QZ
 for bug-gnu-emacs@HIDDEN; Thu, 15 Oct 2020 20:10:50 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; Prefer selection of colour emoji fonts?
X-Now-Playing: Antony and the Johnsons's _I Am A Bird Now_: "Fistful Of Love"
Date: Thu, 15 Oct 2020 20:10:44 +0200
Message-ID: <87tuuvtl5n.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  If I start "emacs -Q" and load a file with this character:
    🎉 Emacs shows that as a black-and-white symbol using the Symbola font.
    
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
Received-SPF: pass client-ip=2a01:4f9:2b:f0f::2; envelope-from=larsi@HIDDEN;
 helo=quimby.gnus.org
X-detected-operating-system: by eggs.gnu.org: No matching host in p0f cache.
 That's all we know.
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


If I start "emacs -Q" and load a file with this character:

=F0=9F=8E=89

Emacs shows that as a black-and-white symbol using the Symbola font.

If I then say

(set-fontset-font t 'symbol "Noto Color Emoji")
(set-fontset-font t 'symbol "Symbola" nil 'append)

I get a colourful party popper.

It'd be nice if this worked out of the box.  What do other programs do?
Have a huge list of fonts they prefer over other fonts?


In GNU Emacs 28.0.50 (build 49, x86_64-pc-linux-gnu, GTK+ Version 3.24.23, =
cairo version 1.16.0)
 of 2020-10-14 built on xo
Repository revision: 1ee5a4cb1afe5a55d78e35cab2ad8651196c8967
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12008000
System Description: Debian GNU/Linux bullseye/sid


--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Acknowledgement sent to Lars Ingebrigtsen <larsi@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#44020; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 19 Oct 2020 18:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.